---
title: ContentIndexEvent
slug: Web/API/ContentIndexEvent
tags:
  - Content
  - Content Index API
  - Index
  - Interface
  - PWA
  - content indexing
---
<div>{{draft}}{{DefaultAPISidebar("Content Index API")}}</div>

<p class="summary">The <strong><code>ContentIndexEvent</code></strong> interface of the {{domxref('Content Index API')}} defines the object used to represent the {{Event('contentdelete')}} event.</p>

<p>This event is sent to the {{domxref('ServiceWorkerGlobalScope','global scope')}} of a {{domxref('ServiceWorker')}}. It contains the id of the indexed content to be removed.</p>

<p>The {{Event('contentdelete')}} event is only fired when the deletion happens due to interaction with the browser's built-in user interface. It is not fired when the {{domxref('ContentIndex.delete')}} method is called.</p>

<h2 id="Constructor">Constructor</h2>

<dl>
  <dt>{{domxref("ContentIndexEvent.ContentIndexEvent", "ContentIndexEvent()")}}</dt>
  <dd>Creates and returns a new <code>ContentIndexEvent</code> object whose type and other options are configured as specified.</dd>
</dl>

<h2 id="Properties">Properties</h2>

<p><em>In addition to the properties listed below, this interface inherits the properties of its parent interface, {{domxref("ExtendableEvent")}}.</em></p>

<dl>
  <dt>{{domxref("ContentIndexEvent.id", "id")}} {{ReadOnlyInline}}</dt>
  <dd>A {{jsxref('String')}} which identifies the deleted content index via it's <code>id</code>.</dd>
 </dl>

<h2 id="Methods">Methods</h2>

<p><em>While <code>ContentIndexEvent</code> offers no methods of its own, it inherits any specified by its parent interface, {{domxref("ExtendableEvent")}}.</em></p>

<h2 id="Examples">Examples</h2>

<p>This example shows the {{domxref('ServiceWorker','sevice worker')}} script listening for the {{domxref('ContentIndexEvent', 'contentdelete')}} event and logs the removed content index id.</p>

<pre class="brush: js notranslate">self.addEventListener('contentdelete', (event) =&gt; {
  console.log(event.id);

  // logs content index id, which can then be used to determine what content to delete from your cache

});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Content Index API','#content-index-event','ContentIndexEvent')}}</td>
   <td>{{Spec2('Content Index API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.ContentIndexEvent")}}</p>

<h2 id="See_also">See also:</h2>

<ul>
  <li><a href="https://web.dev/content-indexing-api/">An introductory article on the Content Index API</a></li>
  <li><a href="https://contentindex.dev/">An app which uses the Content Index API to list and remove 'save for later' content</a></li>
  <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API, along with information about Cache and CacheStorage</a></li>
</ul>
